﻿Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim dt As DataTable = New DataTable()
        dt.Columns.AddRange(New DataColumn(3) {New DataColumn("Id", GetType(Integer)), New DataColumn("Name", GetType(String)), New DataColumn("City", GetType(String)), New DataColumn("Country", GetType(String))})
        dt.Rows.Add(1, "John Hammond", "Chicago", "United States")
        dt.Rows.Add(2, "Mudassar Khan", "Mumbai", "India")
        dt.Rows.Add(3, "Suzanne Mathews", "Paris", "France")
        dt.Rows.Add(4, "Robert Schidner", "Moscow", "Russia")
        Me.dataGridView1.DataSource = dt
    End Sub

    Private Sub dataGridView1_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles dataGridView1.Paint
        'Offsets to adjust the position of the merged Header.
        Dim heightOffset As Integer = -5
        Dim widthOffset As Integer = -2
        Dim xOffset As Integer = 0
        Dim yOffset As Integer = 4

        'Index of Header column from where the merging will start.
        Dim columnIndex As Integer = 2

        'Number of Header columns to be merged.
        Dim columnCount As Integer = 2

        'Get the position of the Header Cell.
        Dim headerCellRectangle As Rectangle = dataGridView1.GetCellDisplayRectangle(columnIndex, 0, True)

        'X coordinate  of the merged Header Column.
        Dim xCord As Integer = (headerCellRectangle.Location.X + xOffset)

        'Y coordinate  of the merged Header Column.
        Dim yCord As Integer = ((headerCellRectangle.Location.Y - headerCellRectangle.Height) + yOffset)

        'Calculate Width of merged Header Column by adding the widths of all Columns to be merged.
        Dim mergedHeaderWidth As Integer = (dataGridView1.Columns(columnIndex).Width + (dataGridView1.Columns((columnIndex + (columnCount - 1))).Width + widthOffset))

        'Generate the merged Header Column Rectangle.
        Dim mergedHeaderRect As Rectangle = New Rectangle(xCord, yCord, mergedHeaderWidth, (headerCellRectangle.Height + heightOffset))

        'Draw the merged Header Column Rectangle.
        e.Graphics.FillRectangle(New SolidBrush(Color.White), mergedHeaderRect)

        'Draw the merged Header Column Text.
        e.Graphics.DrawString("Address", dataGridView1.ColumnHeadersDefaultCellStyle.Font, Brushes.Black, (xCord + 2), (yCord + 3))
    End Sub
End Class
